SystemOrganization addCategory: #'Seaside-Tests-UTF8'!

!WAPackage class methodsFor: '*seaside-tests-utf8' stamp: 'pmm 7/4/2009 23:33'!
seasideTestsUtf8
	^ self new
		name: 'Seaside-Tests-UTF8';
		description: 'Unit tests for UTF8 support.';
		addDependency: 'Seaside-Tests-Core';
		yourself! !

TestCase subclass: #WAUtf8CodecTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-UTF8'!

!WAUtf8CodecTest methodsFor: 'private' stamp: 'pmm 7/4/2009 23:39'!
asString: aCollectionOfIntegers
	^String streamContents: [ :stream |
		aCollectionOfIntegers do: [ :each |
			stream nextPut: (Character value: each) ] ]! !

!WAUtf8CodecTest methodsFor: 'accessing' stamp: 'pmm 7/4/2009 23:36'!
latin1String
	^ self asString: #(220 98 232 114 115 116 114 238 241 103 233)! !

!WAUtf8CodecTest methodsFor: 'testing' stamp: 'pmm 7/4/2009 23:35'!
testCodecUtf8
	| codec |
	codec := WACodec forEncoding: 'utf-8'.
	
	self assert: codec name = 'utf-8'.
	self assert: codec url name = 'utf-8'.
	
	self assert: (codec encode: self latin1String) = self utf8String.
	self assert: (codec url encode: self latin1String) = self utf8String.
	self assert: (codec decode: self utf8String) = self latin1String.
	self assert: (codec url decode: self utf8String) = self latin1String! !

!WAUtf8CodecTest methodsFor: 'testing' stamp: 'pmm 7/4/2009 23:35'!
testCodecUtf8Binary
	| codec binary encoder |
	codec := WACodec forEncoding: 'utf-8'.
	binary := self utf8String asByteArray.
	encoder := codec encoderFor: (WriteStream on: String new).
	encoder binary.
	encoder nextPutAll: binary.
	self assert: encoder contents = binary asString! !

!WAUtf8CodecTest methodsFor: 'testing' stamp: 'pmm 7/4/2009 23:35'!
testCodecUtf8Bom
	| codec bom |
	codec := WACodec forEncoding: 'utf-8'.
	bom := self asString: #(16rEF 16rBB 16rBF).
	
	self assert: (codec decode: bom , self utf8String) = self latin1String.
	self assert: (codec url decode: bom , self utf8String) = self latin1String! !

!WAUtf8CodecTest methodsFor: 'testing' stamp: 'pmm 7/4/2009 23:35'!
testCodecUtf8ShortestForm
	"Non shortest form characters should be rejected
	See Corrigendum #1: UTF-8 Shortest Form http://www.unicode.org/versions/corrigendum1.html"
	| codec abc |
	codec := WACodec forEncoding: 'utf-8'.
	abc := self asString: #(16rC1 16r81 16rC1 16r82 16rC1 16r83).
	
	self assert: (codec decode: abc) ~= 'ABC'! !

!WAUtf8CodecTest methodsFor: 'accessing' stamp: 'pmm 7/4/2009 23:36'!
utf8String
	^ self asString: #(195 156 98 195 168 114 115 116 114 195 174 195 177 103 195 169)! !
